import { World, Commands } from 'mojang-minecraft'

World.events.tick.subscribe((tick) => {
    var players = World.getPlayers()
    var dimension = World.getDimension('overworld')


    players.forEach(player => {
        let tags = Commands.run(`/tag "${player.name}" list`, dimension).statusMessage
        let tagsSplit = tags.split(';')

        if(tags.search("searchInv;") != -1) {
            let item = tagsSplit[1]
            let func = tagsSplit[3]
            let tag = "searchInv;" + item + ";;" + func + ";"

            Commands.run(`/tag "${player.name}" remove "${tag}"`, dimension)

            try {
                let check = Commands.run(`/clear "${player.name}" ${item} 0 0`, dimension).statusMessage
                if(check.search("items that match the criteria") != -1) {
                    Commands.run(`/tag "${player.name}" add return:found`, dimension)
                }
            } finally {
                if(func) {
                    Commands.run(`/execute "${player.name}" ~~~ function ${func}`, dimension)
                }
            }
        }
        
        else if(tags.search("tagName;") != -1) {
            let selector = tagsSplit[1]
            let tag = "tagName;" + selector + ";"

            Commands.run(`/tag "${player.name}" remove "${tag}"`, dimension)

            Commands.run(`/execute "${player.name}" ~~~ tag ${selector} add "${player.name}"`, dimension)
        }

        else if(tags.search("execTagName;") != -1) {
            let selector = tagsSplit[1]
            let runAs = tagsSplit[3]
            let func = tagsSplit[5]
            let tag = "execTagName;" + selector + ";;" + runAs + ";;" + func + ";"

            Commands.run(`/tag "${player.name}" remove "${tag}"`, dimension)

            if(runAs == "player") {
                Commands.run(`/execute "${player.name}" ~~~ execute ${selector},tag="${player.name}"] ~~~ execute "${player.name}" ~~~ function ${func}`, dimension)
            } else if(runAs == "selector") {
                Commands.run(`/execute "${player.name}" ~~~ execute ${selector},tag="${player.name}"] ~~~ function ${func}`, dimension)
            }
        }

        else if(tags.search("summonName;") != -1) {
            let type = tagsSplit[1]
            let xPos = tagsSplit[3]
            let yPos = tagsSplit[5]
            let zPos = tagsSplit[7]
            let event = tagsSplit[9]
            let pos = xPos + " " + yPos + " " + zPos
            let tag = "summonName;" + type + ";;" + xPos + ";;" + yPos + ";;" + zPos + ";;" + event + ";"

            Commands.run(`/tag "${player.name}" remove "${tag}"`, dimension)

            if(event) {
                Commands.run(`/execute "${player.name}" ~~~ summon ${type} ${pos} ${event} "${player.name}"`, dimension)
            } else {
                Commands.run(`/execute "${player.name}" ~~~ summon ${type} "${player.name}" ${pos}`, dimension)
            }
        }
    })
})